Package: RcppRedis
Type: Package
Title: 'Rcpp' Bindings for 'Redis' using the 'hiredis' Library
Version: 0.2.6
Date: 2025-06-24
Authors@R: c(person("Dirk", "Eddelbuettel", role = c("aut", "cre"), email = "edd@debian.org",
                    comment = c(ORCID = "0000-0001-6419-907X")),
             person("Bryan", "Lewis", role = "aut", comment = "pub/sub code from 'rredis'"))
Description: Connection to the 'Redis' (or 'Valkey') key/value store
 using the C-language client library 'hiredis' (included as a fallback)
 with 'MsgPack' encoding provided via 'RcppMsgPack' headers. It now
 also includes the pub/sub functions from the 'rredis' package.
SystemRequirements: An available hiredis library (eg via package
        libhiredis-dev on Debian/Ubuntu, hiredis-devel on
        Fedora/RedHat, or directly from source from
        <https://github.com/redis/hiredis>) can be used but version
        1.0.2 is also included and built on demand if needed. The
        optional 'rredis' package can be installed from the 'ghrr'
        'drat' repo for additional illustrations and tests.
URL: https://github.com/eddelbuettel/rcppredis,
        https://dirk.eddelbuettel.com/code/rcpp.redis.html
BugReports: https://github.com/eddelbuettel/rcppredis/issues
License: GPL (>= 2)
Imports: methods, Rcpp (>= 0.11.0), RApiSerialize (>= 0.1.4)
LinkingTo: Rcpp, RApiSerialize
Suggests: RcppMsgPack, tinytest
NeedsCompilation: yes
Packaged: 2025-06-24 14:09:03 UTC; edd
Author: Dirk Eddelbuettel [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6419-907X>),
  Bryan Lewis [aut] (pub/sub code from 'rredis')
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Repository: CRAN
Date/Publication: 2025-06-24 14:30:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 21:39:08 UTC; unix
Archs: RcppRedis.so.dSYM

useDynLib(RcppRedis, .registration=TRUE)	# shared library from this package
import(methods,Rcpp,RApiSerialize)	        # packages we require
exportPattern("^[[:alpha:]]+")          	# export all identifiers starting with letters

## RcppRedis: RcppRedis is a Rcpp and hiredis-based Redis client for R

[![CI](https://github.com/eddelbuettel/rcppredis/workflows/ci/badge.svg)](https://github.com/eddelbuettel/rcppredis/actions?query=workflow%3Aci)
[![License](https://img.shields.io/badge/license-GPL%20%28%3E=%202%29-brightgreen.svg?style=flat)](https://www.gnu.org/licenses/gpl-2.0.html)
[![CRAN](https://www.r-pkg.org/badges/version/RcppRedis)](https://cran.r-project.org/package=RcppRedis)
[![r-universe](https://eddelbuettel.r-universe.dev/badges/RcppRedis)](https://eddelbuettel.r-universe.dev/RcppRedis)
[![Dependencies](https://tinyverse.netlify.app/badge/RcppRedis)](https://cran.r-project.org/package=RcppRedis)
[![Downloads](https://cranlogs.r-pkg.org/badges/RcppRedis?color=brightgreen)](https://www.r-pkg.org:443/pkg/RcppRedis)
[![Last Commit](https://img.shields.io/github/last-commit/eddelbuettel/rcppredis)](https://github.com/eddelbuettel/rcppredis)

### Dependencies

The package has three dependencies that should be easily resolvable:

- [hiredis](https://github.com/redis/hiredis), the main C library for redis, eg via
  [libhiredis-dev](https://packages.debian.org/sid/libhiredis-dev) on Debian or Ubuntu; as
  a fallback [hiredis](https://github.com/redis/hiredis) is also included
- [Rcpp](https://github.com/RcppCore/Rcpp) for seamless R and C++ integration (on
  [CRAN](https://cran.r-project.org/package=Rcpp))
- [RApiSerialize](https://github.com/eddelbuettel/rapiserialize) for C-level serialization
  from the R API (on [CRAN](https://cran.r-project.org/package=RApiSerialize)) , and if
  so, of sufficient vintage80

The package should install from source like any other R package. If the a
[hiredis](https://github.com/redis/hiredis) library is found, it will be used. The
`pkg-config` script is used to find the hiredis headers and library. Otherwise the
embedded [hiredis](https://github.com/redis/hiredis) is used.  All of Rcpp, RApiSerialized
and RcppRedis can be installed directly from [CRAN](https://cran.r-project.org) (which is
the recommended approach) or GitHub.

[MessagePack](http://msgpack.org/index.html) support is optional, and provided by
[RcppMsgPack](https://github.com/eddelbuettel/rcppmsgpack) package on
[CRAN](https://cran.r-project.org/package=RcppMsgPack) which, if installed, is used to
provide [MessagePack](http://msgpack.org/index.html) headers for
[MessagePack](http://msgpack.org/index.html) serialization.

A backend is needed to run the code. The package will work with any protocol-compatible backend and
for example [valkey](https://valkey.io/) (which is increasingly replacing redis) works just fine.

### Getting Started

Run some of the scripts from the `demos/` or `examples/` directories.

### Status

The package works well, is used in production, and has been on
[CRAN](https://cran.r-project.org) for some time.

It is however only providing a subset of the Redis API.

### History

This package was derived from an initial fork of an earlier attempt named
'rhiredis' by Wush Wu, and has since been extended in a number of
ways. William Pleasant provided some early patches. Whit Armstrong and
Russell Pierce contributed extensions. We also offered a new home for the
pub/sub mechanism first implemented in the now archived package `rredis` by
Bryan W. Lewis.

### Authors

Dirk Eddelbuettel and Bryan W. Lewis, based on earlier work by Wush Wu and
with contributions by William Pleasant, Russell Pierce and Whit Armstrong.

### License

GPL (>= 2)

## Pub/Sub Example with 'Live' Intra-Daily Market Data

### What Is This?

This directory contains a pair of files to gather and display "live" (_i.e._
delayed by the usual amount as is common for non-subscribers to generally
expensive live market data) futures data.

### What Does It Look Like?

Here is a screenshot from a few months ago. The plotting logic and details have
not changed. Displayed are two days worth of price snapshots every ten seconds.

![](example_screenshot.png)

### Give Me More Details

One file uses package [quantmod](https://cloud.r-project.org/package=quantmod)
to gather the data. It collects the data points in [Redis](https://redis.io) to
build a history, but also publishes the on a channel by the name of the symbol.

The second file retrieves the recent history, and subscribes to the channel to
receive updates which it displays as it gets them.  Because it uses an R
graphics device to plot (also via package
[quantmod](https://cloud.r-project.org/package=quantmod)) it is easiest to
`source()` the file in an R session. (`Rscript` defaults to setting
`interactive` to FALSE; otherwise R can be used with `--interactive`, or `r`
from [littler](https://cloud.r-project.org/package=quantmod) can be used with
its `-i` switch).

The third file should be invoked weekly or daily from `crontab` and prunes the
history down to just the last months.  All three files could be generalized to
read more than one symbol, or host, or ... from config files.  For now, and for
simplicity, just the front ES contract is monitored.

### Going Further

The second set of files generalizes the approach to subscribe to a set of
symbols---where we use a set of symbols from CME Globex, an electronic trading
system with extended hours.
Data for each symbols is cached, and published, in the 'to-Redis' file.
The corresponding 'from-Redis' file consumes and plots the data, again using a
single process to cover multiple symbols and subscriptions.

### Acknowledgements

These files owes their basic structure to a [gist by Josh Ulrich](https://gist.github.com/joshuaulrich/ee11ef67b1461df399b84efd3c8f9f67#file-intraday-sp500-r)
which also contained the basic subscription loop (and which is also the basis of
this [extended and documented version in package
dang](https://github.com/eddelbuettel/dang/blob/master/R/intradayMarketMonitor.R). This
was then generalized to use a symbol such as `ES=F` (for the front month SP500
futures contract) for which no history is available by both caching in [Redis](https://redis.io)
and using pub/sub to distribute.  The `rredis` package (installable from the
[ghrr drat](https://ghrr.github.io/drat) repo) was used for the initial
pub/sub approach.  Bryan W. Lewis then ported and adapted the pub/sub model to
this RcppRedis package.

### Authors

Dirk Eddelbuettel, Joshua Ulrich, Bryan W. Lewis

### License

GPL (>= 2)

suppressMessages({
    library(RcppRedis)
    ## use install.packages("rredis", repos=c("https://ghrr.github.io/drat", getOption("repos")))
    library(rredis)
    library(rbenchmark)
})

data(trees)
fit <- lm(log(Volume) ~ log(Girth) + log(Height), data=trees)


redis <- new(Redis)
rredis::redisConnect(nodelay=TRUE)      # new rredis option to mimich networking behavior of hiredis

## writes as ascii
hiredis <- function() redis$exec(paste0("SET fits1 ",
                                        rawToChar(serialize(fit,NULL,ascii=TRUE))))

## writes as binary
rredis <- function() rredis::redisSet("fits2", fit)

## writes as binary
hiredisInt <- function() redis$set("fits3", fit)


res <- benchmark(hiredis(), rredis(), hiredisInt(), replications=500, order="relative")[,1:4]
cat("\nResults for SET\n")
print(res)

stopifnot(all.equal(unserialize(charToRaw(redis$exec("GET fits1"))), fit))
stopifnot(all.equal(rredis::redisGet("fits2"), fit))
stopifnot(all.equal(rredis::redisGet("fits3"), fit))



hiredis <- function() unserialize(charToRaw(redis$exec("GET fits1")))

rredis <- function() rredis::redisGet("fits2")

hiredisInt <- function() redis$get("fits3")


res <- benchmark(hiredis(), rredis(), hiredisInt(), replications=500, order="relative")[,1:4]
cat("\nResults for GET\n")
print(res)

#!/usr/bin/Rscript

library(methods)
library(RcppRedis)

redis <- new(Redis)

key1 <- "ex:ascii:simpleString"
val1 <- redis$getString(key1)
cat("Got", val1, "from", key1, "\n")

key2 <- "ex:ascii:scalarVal"
val2 <- redis$listLPop(key2)
cat("Got", val2, "from", key2, "\n")

key3 <- "ex:ascii:vectorVal"
val3 <- redis$listLPop(key3)
cat("Got from", key3, "\n")
print(str(val3))

key4 <- "ex:ascii:vectorVal"
val4 <- redis$listRangeAsStrings(key4, 0, -1)
cat("Got from", key4, "\n")
print(val4)

#!/usr/bin/Rscript

suppressMessages(library(RcppRedis))
print(Redis)

## simple ping / pong test
redis <- new(Redis)
redis$exec("PING")
redis$exec("PING")

## set and retrieve a number
redis2 <- new(Redis, "127.0.0.1", 6379)
redis2$exec("SET testchannel 42")
redis2$exec("GET testchannel")

## set and retrieve a complete R object
data(trees)
fit <- lm(log(Volume) ~ log(Girth) + log(Height), data=trees)
redis$exec(paste("SET fits ", rawToChar(serialize(fit,NULL,ascii=TRUE)), sep=""))
all.equal(unserialize(charToRaw(redis$exec("GET fits"))), fit)

#!/usr/bin/Rscript

library(methods)
library(RcppRedis)

redis <- new(Redis)

key1 <- "ex:ascii:simpleString"
val1 <- "abracadrabra"
res <- redis$setString(key1, val1)
cat("Wrote", val1, "for", key1, "with result", res, "\n")

#key2 <- "scalarVal"
#val2 <- redis$listRange(key2, 0, -1)
#cat("Got", val2, "from", key2, "\n")
#print(str(val2))

#key3 <- "vectorVal"
#val3 <- redis$listRange(key3, 0, -1)
#cat("Got", val2, "from", key2, "\n")
#print(str(val3))

#key4 <- "vectorVal"
#val4 <- redis$listRangeAsStrings(key4, 0, -1)
#print(val4)

## Initial version by Iñaki Ucar using Redux
## Adapted to RcppRedis by Dirk Eddelbuettel

useRcppRedis <- function() {

    ensure_queue <- function(name) {
        ##list(con = redux::hiredis(), name = name, temp = paste0(name, "_temp"))
        redis <- new(RcppRedis::Redis)
        list(con = redis, name = name, temp = paste0(name, "_temp"))
    }

    publish <- function(queue, message) {
        ##invisible(queue$con$LPUSH(queue$name, message))
        invisible(queue$con$lpush(queue$name, message))
    }

    list_messages <- function(queue) {
        ##list(READY = queue$con$LRANGE(queue$name, 0, -1),
        ##     PROCESSING = queue$con$LRANGE(queue$temp, 0, -1))
        list(READY = queue$con$lrange(queue$name, 0, -1),
             PROCESSING = queue$con$lrange(queue$temp, 0, -1))
    }

    try_consume <- function(queue) {
        ##message <- queue$con$RPOPLPUSH(queue$name, queue$temp)
        message <- queue$con$lmove(queue$name, queue$temp, 'RIGHT', 'LEFT')
        if (is.null(message)) return(message)
        list(queue = queue, message = message)
    }

    ack <- function(message) {
        ##invisible(message$queue$con$LREM(message$queue$temp, 1, message$message))
        invisible(message$queue$con$lrem(message$queue$temp, 1, message$message))
    }

    #############################################################################

    ##system("docker run -d --rm --name valkey -p 6379:6379 valkey/valkey")
    ## assume Redis running

    q <- ensure_queue("jobs")
    ##q

    publish(q, message = "Hello world!")
    publish(q, message = "Hello again!")
    cat("\n--Messages after two enqueus\n")
    str(list_messages(q))

    msg <- try_consume(q)
    cat("\n--Consumed message 1\n")
    msg$message
    cat("\n--Messages after consume\n")
    str(list_messages(q))

    print(ack(msg))
    cat("\n--Messages after ack 1\n")
    str(list_messages(q))

    msg2 <- try_consume(q)
    cat("\n--Consumed message 2\n")
    msg2$message
    print(ack(msg2))
    cat("\n--Messages after ack 2\n")
    str(list_messages(q))

    cat("\n--Final try consume\n")
    str(try_consume(q))

    ##system("docker stop valkey")
}

useRedux <- function() {
    ensure_queue <- function(name) {
        list(con = redux::hiredis(), name = name, temp = paste0(name, "_temp"))
    }

    publish <- function(queue, message) {
        invisible(queue$con$LPUSH(queue$name, message))
    }

    list_messages <- function(queue) {
        list(READY = queue$con$LRANGE(queue$name, 0, -1),
             PROCESSING = queue$con$LRANGE(queue$temp, 0, -1))
    }

    try_consume <- function(queue) {
        message <- queue$con$RPOPLPUSH(queue$name, queue$temp)
        if (is.null(message)) return(message)
        list(queue = queue, message = message)
    }

    ack <- function(message) {
        invisible(message$queue$con$LREM(message$queue$temp, 1, message$message))
    }

    #############################################################################

    ## #system("docker run -d --rm --name valkey -p 6379:6379 valkey/valkey")

    q <- ensure_queue("jobs")
    ##q

    publish(q, message = "Hello world!")
    publish(q, message = "Hello again!")
    cat("\n--Messages after two enqueus\n")
    str(list_messages(q))

    msg <- try_consume(q)
    cat("\n--Consumed message 1\n")
    msg$message
    cat("\n--Messages after consume\n")
    str(list_messages(q))

    print(ack(msg))
    cat("\n--Messages after ack 1\n")
    str(list_messages(q))

    msg2 <- try_consume(q)
    cat("\n--Consumed message 2\n")
    msg2$message
    print(ack(msg2))
    cat("\n--Messages after ack 2\n")
    str(list_messages(q))

    cat("\n--Final try consume\n")
    str(try_consume(q))

    ##system("docker stop valkey")

}

quickCheck <- function() {
    redis <- new(RcppRedis::Redis)
    redis$lpush("foo", "banana")
    redis$lpush("foo", "banana")
    #print(str(redis$lrange("foo", 0, -1)))
    print(redis$llen("foo"))
    redis$lrem("foo", 1, "banana")
    #print(str(redis$lrange("foo", 0, -1)))
    print(redis$llen("foo"))
    redis$lpop("foo")
    #print(str(redis$lrange("foo", 0, -1)))
    print(redis$llen("foo"))
    invisible(NULL)
}

useRcppRedis()
#useRedux()
#quickCheck()

## cf https://gist.github.com/joshuaulrich/ee11ef67b1461df399b84efd3c8f9f67#file-intraday-sp500-r

suppressMessages({
    library(quantmod)
    library(RcppRedis)
})

defaultTZ <- "America/Chicago"
symbol <- "ES=F"

get_data <- function(symbol) {
    quote <- getQuote(symbol)
    vec <- c(Time = as.numeric(quote$`Trade Time`),
             Close = quote$Last,
             Change = quote$Change,
             PctChange = quote$`% Change`,
             Volume = quote$Volume)
    vec
}

store_data <- function(vec, symbol) {
    redis$zadd(symbol, matrix(vec, 1))
    redis$publish(symbol, paste(vec,collapse=";"))
}

msg <- function(ts, ...) {
    op <- options(digits.secs=3)
    cat(format(ts), ..., "\n")
    options(op)
}

x <- NULL
redis <- new(Redis, "localhost")
if (redis$ping() != "PONG") stop("No Redis server?", call. = FALSE)

market_closed <- TRUE
errored <- FALSE
prevVol <- 0
repeat {
    curr_t <- Sys.time()
    now_t <- xts(, curr_t)
    now <- .indexhour(now_t)*100 + .indexmin(now_t)
    if (now >= 1525 && now < 1710) {
        ## we need one NA observations to plot a gap
        vec <- c(Time = as.numeric(curr_t),
                 Close = NA_real_,
                 Change = NA_real_,
                 PctChange = NA_real_,
                 Volume = NA_real_)
        store_data(vec, symbol)
        tgt <- as.POSIXct(paste(format(as.Date(curr_t)), "17:09:59.999"))
        dt <- max(1L,round(as.numeric(difftime(tgt, curr_t, units="secs")),0))
        msg(index(now_t), "after close; setting NA, sleeping", dt, "seconds")
        Sys.sleep(dt)
        market_closed <- TRUE
        next
    } else if ((now >= 1710 || now < 1526) && market_closed) {
        msg(index(now_t), "market open")
        market_closed <- FALSE
        prevVol <- 0
    }
    y <- try(get_data(symbol), silent = TRUE)
    if (inherits(y, "try-error")) {
        msg(curr_t, "Error:", attr(y, "condition")[["message"]])
        errored <- TRUE
        Sys.sleep(15)
        next
    } else if (errored) {
        errored <- FALSE
        msg(curr_t, "...recovered")
    }
    v <- y["Volume"]
    if (v != prevVol) {
        store_data(y, symbol)
        msg(curr_t, "Storing data from", format(anytime::anytime(y["Time"])), "close", y["Close"], "change", y["Change"])
    }
    prevVol <- v
    Sys.sleep(10)
}

suppressMessages({
    library(quantmod)
    library(anytime)
    library(RcppRedis)
})

defaultTZ <- "America/Chicago"
symbol <- "ES=F"
host <- "localhost"
ndays <- 2

most_recent_n_days <- function(x, n=2, minobs=1500) {
    tt <- table(as.Date(index(x)))
    if (length(tt) < n) return(x)
    cutoff <- paste(format(as.Date(names(head(tail(tt[tt>minobs], n), 1)))), "00:00:00")
    newx <- x[ index(x) >= as.POSIXct(cutoff) ]
    msg(Sys.time(), "most recent data starting at", format(head(index(newx),1)))
    newx
}

get_all_data <- function(symbol, host) {
    m <- redis$zrange(symbol, 0, -1)
    colnames(m) <- c("Time", "Close", "Change", "PctChange", "Volume")
    y <- xts(m[,-1], order.by=anytime(as.numeric(m[,1])))
    y
}

show_plot <- function(symbol, x) {
    lastx <- tail(coredata(x),1)
    cname <- paste(symbol,
                   format(lastx[,"Close"]),
                   round(lastx[,"Change"], 2),
                   round(lastx[,"PctChange"], 5),
                   format(Sys.time(), "%H:%M:%S"),
                   sep = "   ")
    cs <- quantmod::chart_Series(x[,"Close"], name = cname)
    ## cf issue 270
    ##    chart_Series(IBM, name=NULL)
    ##    title('IBM', font.main=3, col.main="#ff0000", line=2.5)
    plot(cs)
}

msg <- function(ts, ...) {
    op <- options(digits.secs=3)
    cat(format(ts), ..., "\n")
    options(op)
}

redis <- new(Redis, host)
if (redis$ping() != "PONG") stop("No Redis server?", call. = FALSE)
x <- get_all_data(symbol, host)
x <- most_recent_n_days(x,ndays)
show_plot(symbol, x)

## This is the callback function assigned to a symbol
.data2xts <- function(x) {
    m <- read.csv(text=x, sep=";", header=FALSE, col.names = c("Time", "Close", "Change", "PctChange", "Volume"))
    y <- xts(m[,-1,drop=FALSE], anytime(as.numeric(m[,1,drop=FALSE])))
    y
}
assign(symbol, .data2xts)               # programmatic version of callback `ES=F` <- function(x) ....
redis$subscribe(symbol)

market_closed <- TRUE
repeat {
    curr_t <- Sys.time()
    now_t <- xts(, curr_t)
    now <- .indexhour(now_t)*100 + .indexmin(now_t)
    if (now >= 1525 && now < 1710) {    # this may not get hit on futures ...
        x <- most_recent_n_days(x,ndays)
        tgt <- as.POSIXct(paste(format(as.Date(curr_t)), "17:09:59.999"))
        dt <- max(1,round(as.numeric(difftime(tgt, curr_t, units="secs")),0))
        msg(index(now_t), "after close; sleeping", dt, "seconds")
        Sys.sleep(dt)
        market_closed <- TRUE
        next
    } else if ((now >= 1710 || now < 1526) && market_closed) {
        x <- most_recent_n_days(x,ndays)
        msg(index(now_t), "market open")
        market_closed <- FALSE
        prevVol <- 0
    }
    y <- redisMonitorChannels(redis)
    if (!is.null(y)) {
        x <- rbind(x,y)
        x <- x[!duplicated(index(x))]
        ll <- tail(y,1)
        msg(Sys.time(), "data", format(index(ll)), "close", ll[1,"Close"], "change", ll[1, "Change"])
    } else {
        msg(index(now_t), "null data in y")
    }
    show_plot(symbol, x)
}
# never reached but could do 'redis$unsubscribe(symbol)' here

library(xts)
library(rredis) # use install.packages("rredis", repos=c("https://ghrr.github.io/drat", getOption("repos")))
library(RcppRedis)
library(rbenchmark)

set.seed(123)

N <- 2500

x <- xts(100*cumprod(1+rnorm(N)*0.005 + (runif(N)>0.95)*rnorm(N)*0.025),
         order.by=Sys.time()+cumsum(exp(3*runif(N))))
plot(x, main="Simulated Series", type='l')

redisConnect()
redis <- new(Redis)

dat <- data.frame(key=as.numeric(index(x)), val=coredata(x))

setAsAscii <- function(dat) {
    N <- nrow(dat)
    ## insertion is row by row
    for (i in 1:N) {
        redisZAdd("ex:ascii:series", dat[i,1], dat[i,])
    }
}

## retrieval is by list
getFromAscii <- function() {
    xx <- do.call(rbind, redisZRange("ex:ascii:series", 0, -1))
    xt <- xts(xx[,-1], order.by=as.POSIXct(xx[,1], origin="1970-01-01"))
}

setAsBinary <- function(dat) {
    redis$zadd("ex:bin:series", as.matrix(dat))
}

getFromBinary <- function() {
    zz <- redis$zrange("ex:bin:series", 0, -1)
    zt <- xts(zz[,-1], order.by=as.POSIXct(zz[,1], origin="1970-01-01"))
}

redis$zremrangebyscore("ex:ascii:series", 0, Inf)
redis$zremrangebyscore("ex:bin:series", 0, Inf)

cat("Writing ascii ... patience\n")
setAsAscii(dat)
setAsBinary(dat)

xt <- getFromAscii()
zt <- getFromBinary()
identical(xt,zt)

redis$zremrangebyscore("ex:ascii:series", 0, Inf)
redis$zremrangebyscore("ex:bin:series", 0, Inf)

benchmark(setAsAscii(dat), setAsBinary(dat),
          replications=1, order="relative")[,1:4]


benchmark(getFromAscii(), getFromBinary(), replications=10, order="relative")[,1:4]

suppressMessages({
    library(RcppRedis)
    ## use install.packages("rredis", repos=c("https://ghrr.github.io/drat", getOption("repos")))
    library(rredis)
})

data(trees)
fit <- lm(log(Volume) ~ log(Girth) + log(Height), data=trees)

redis <- new(Redis)
rredis::redisConnect(nodelay=TRUE)      # new rredis option to mimich networking behavior of hiredis

## set a serialized object
key <- "foo"
redis$set(key, serialize(fit,NULL,ascii=TRUE))


## retrieve with rredis
fit2 <- rredis::redisGet(key)

## check
all.equal(fit, fit2)


## or serialize an object internally
key <- "foo2"
redis$set(key, fit)

## retrieve with rredis
fit3 <- rredis::redisGet(key)

## check
all.equal(fit, fit3)

## retrieve with rredis
fit4 <- redis$get(key)

## check
all.equal(fit, fit4)

library(RcppRedis)
library(rredis)			# use install.packages("rredis", repos=c("https://ghrr.github.io/drat", getOption("repos")))
library(rbenchmark)

data(trees)
fit <- lm(log(Volume) ~ log(Girth) + log(Height), data=trees)

rawfit <- rawToChar(serialize(fit,NULL,ascii=TRUE))

redis <- new(Redis)
rredis::redisConnect()

hiredis <- function() redis$exec(paste("SET fits1 ",
                                       rawToChar(serialize(fit,NULL,ascii=TRUE)),
                                       sep=""))
rredis <- function() rredis::redisSet("fits2", fit)

res <- benchmark(hiredis(), rredis(), replications=100)[,1:4]
print(res)

all.equal(unserialize(charToRaw(redis$exec("GET fits1"))), fit)
all.equal(rredis::redisGet("fits2"), fit)

if (redisExists("abc1")) redisDelete("abc1")
if (redisExists("abc2")) redisDelete("abc2")

abc <- paste0(rep(letters,10),collapse="")

hiredisP<- function() redis$exec(paste0("RPUSH abc1 ",rawToChar(serialize(abc,NULL,ascii=TRUE))))
rredisP <- function() rredis::redisRPush("abc2", abc)

resP <- benchmark(hiredisP(), rredisP(), replications=100)[,1:4]
print(resP)


hiredisLR <-	function() lapply(redis$exec("LRANGE abc1 0 -1"),function(x)unserialize(charToRaw(x)))
rredisLR  <-  function() redisLRange("abc2",0,-1)

resLR <- benchmark(hiredisLR(), rredisLR(), replications=100)[,1:4]
print(resLR)

abc1 <- hiredisLR()
abc2 <- rredisLR()
abcList <- lapply(1:101,function(x) abc)

all.equal(abc1, abcList)
all.equal(abc1, abc2)

suppressMessages({
    library(quantmod)                   # plotting
    library(xts) 		                # data container
    library(anytime)                    # convenient time parsing
    library(RcppRedis)                  # data cache and pub/sub
    #library(ggplot2)                   # for show_plot_gg
    #library(patchwork)                 # for show_plot_gg
})

## Parameters
defaultTZ <- "America/Chicago"
symbols <- c("BTC=F", "CL=F", "ES=F", "GC=F")
host <- "localhost"
ndays <- 2

## Callback handler for convenience
multiSymbolRedisMonitorChannels <- function(context, type="rdata", env=.GlobalEnv) {
    res <- context$listen(type)
    if (length(res) != 3 || res[[1]] != "message") return(res)
    if (exists(res[[2]], mode="function", envir=env)) {
        data <- do.call(res[[2]], as.list(res[[3]]), envir=env)
        val <- list(symbol=res[[2]], data=data)
        return(val)
    }
    res
}

most_recent_n_days <- function(rl, n=2, minobs=1500) {
    rl <- lapply(rl, function(x) {
        tt <- table(as.Date(index(x)))
        if (length(tt) < n || nrow(x) < minobs) return(x)
        cutoff <- paste(format(as.Date(names(head(tail(tt[tt>minobs], n), 1)))), "00:00:00")
        newx <- x[ index(x) >= as.POSIXct(cutoff) ]
        #msg(Sys.time(), "most recent data starting at", format(head(index(newx),1)))
        newx
    })
}

get_all_data <- function(symbols, host) {
    rl <- sapply(symbols, simplify=FALSE, FUN=function(symbol) {
        m <- redis$zrange(symbol, 0, -1)
        colnames(m) <- c("Time", "Close", "Change", "PctChange", "Volume")
        y <- xts(m[,-1,drop=FALSE], order.by=anytime(as.numeric(m[,1,drop=FALSE])))
        y
    })
}

show_plot_base <- function(symbols, rl) {
    dev.hold(1L)                        # thanks to Paul Murrell: hold the plot device ...
    op <- par(no.readonly=TRUE)
    par(mfrow=c(length(symbols), 1))
    res <- lapply(symbols, function(symbol) {
        x <- rl[[symbol]]
        lastx <- tail(coredata(x),1)
        cname <- paste(symbol,
                       format(lastx[,"Close"]),
                       round(lastx[,"Change"], 2),
                       round(lastx[,"PctChange"], 5),
                       format(Sys.time(), "%H:%M:%S"),
                       sep = "   ")
        cs <- quantmod::chart_Series(x[,"Close"], name = cname)
        ## cf issue 270
        ##    chart_Series(IBM, name=NULL)
        ##    title('IBM', font.main=3, col.main="#ff0000", line=2.5)
        plot(cs)
    })
    par(op)
    dev.flush(1L)                       # ... and flush all at once without flicker
}

## alternate using ggplot and patchwork
show_plot_gg <- function(symbols, rl) {
    res <- lapply(symbols, function(symbol) {
        x <- rl[[symbol]]
        lastx <- tail(coredata(x),1)
        cname <- paste(symbol,
                       format(lastx[,"Close"]),
                       round(lastx[,"Change"], 2),
                       round(lastx[,"PctChange"], 5),
                       format(Sys.time(), "%H:%M:%S"),
                       sep = "   ")
        xx <- data.frame(Date=index(x), coredata(x))
        ggplot(data=xx) + aes(x=Date, y=Close) +  geom_line() +
            labs(title = cname, y = "", x = "") +
            theme(plot.title = element_text(size = 9),
                  plot.margin = margin(0, 0, 0, 0, "cm"))
    })
    print(res[[1]] / res[[2]] / res[[3]])
}

show_plot <- show_plot_base
#show_plot <- show_plot_gg

msg <- function(ts, ...) {
    op <- options(digits.secs=3)
    cat(format(ts), ..., "\n")
    options(op)
}

redis <- new(Redis, host)
if (redis$ping() != "PONG") stop("No Redis server?", call. = FALSE)
x <- get_all_data(symbols, host)
x <- most_recent_n_days(x, ndays)
show_plot(symbols, x)

env <- new.env() # local environment for callbacks

## This is the callback function assigned to a symbol
.data2xts <- function(x) {
    m <- read.csv(text=x, sep=";", header=FALSE, col.names = c("Time", "Close", "Change", "PctChange", "Volume"))
    y <- xts(m[,-1,drop=FALSE], anytime(as.numeric(m[,1,drop=FALSE])))
    y
}
## With environment 'env', assign callback function for each symbol
res <- sapply(symbols, function(symbol) {
    assign(symbol, .data2xts, envir=env)  # programmatic version `ES=F` <- function(x) ....
    redis$subscribe(symbol)
})


market_closed <- TRUE
repeat {
    curr_t <- Sys.time()
    now_t <- xts(, curr_t)
    now <- .indexhour(now_t)*100 + .indexmin(now_t)
    if (now >= 1525 && now < 1710) {    # this may not get hit on futures ...
        x <- most_recent_n_days(x,ndays)
        tgt <- as.POSIXct(paste(format(as.Date(curr_t)), "17:09:59.999"))
        dt <- max(1,round(as.numeric(difftime(tgt, curr_t, units="secs")),0))
        msg(index(now_t), "after close; sleeping", dt, "seconds")
        Sys.sleep(dt)
        market_closed <- TRUE
        next
    } else if ((now >= 1710 || now < 1526) && market_closed) {
        x <- most_recent_n_days(x,ndays)
        msg(index(now_t), "market open")
        market_closed <- FALSE
    }
    rl <- multiSymbolRedisMonitorChannels(redis, env=env)  	# monitor channels in context of 'env'
    if (is.list(rl)) {
        sym <- rl[["symbol"]]
        x[[sym]] <- rbind(x[[sym]], rl[["data"]])
        z <- tail(x[[sym]],1)
        if (sym == symbols[3]) msg(Sys.time(), "data", format(index(z)), "close", z[1,"Close"], "change", z[1, "PctChange"])
    } else {
        msg(index(now_t), "null data in y")
    }
    show_plot(symbols, x)
}
# never reached but could do 'redis$unsubscribe(symbol)' here

#!/usr/bin/env r

suppressMessages({
    library(anytime)
    library(RcppRedis)
    library(xts)
})

defaultTZ <- "America/Chicago"
host <- "localhost"
symbols <- c("BTC=F", "ES=F", "GC=F", "CL=F")

redis <- new(Redis, host)
if (redis$ping() != "PONG") stop("No Redis server?", call. = FALSE)

for (symbol in symbols) {
    m <- redis$zrange(symbol, 0, -1)
    colnames(m) <- c("Time", "Close", "Change", "PctChange", "Volume")
    y <- xts(m[,-1], order.by=anytime(as.numeric(m[,1])))
    if (as.numeric(index(y)[1], Sys.time(), units="days") > 30) {
        onemonthago <- Sys.time() - 60*60*24*31
        cutoff <- as.numeric(onemonthago)
        lastold <- max(which(m[, 1] < cutoff ))
        redis$zremrangebyscore(symbol, 0, m[lastold,1])
    }
}

library(rredis) # use install.packages("rredis", repos=c("https://ghrr.github.io/drat", getOption("repos")))
suppressMessages(library(RcppRedis))
suppressMessages(library(xts))
library(rbenchmark)

redisConnect()                          # default localhost
redis <- new(Redis)

if (!redisExists("sp500")) {
    suppressMessages(library(quantmod))
    options("getSymbols.warning4.0"=FALSE)   ## suppress some line noise
    sp <- getSymbols("^GSPC", auto.assign=FALSE, from="1950-01-01", to=Sys.Date())
    redisSet("sp500", sp)
    cat("Downloaded SP500 and stored in redis\n")
} else {
    cat("Retrieving SP500 from redis\n")
    sp <- redisGet("sp500")
}
#print(summary(sp))

rInsert <- function(x) {
    n <- nrow(x)
    key <- "sp500_R"
    if (redisExists(key)) redisDelete(key)
    M <- cbind(as.numeric(index(x)), coredata(x))
    for (i in 1:n) {
        redisRPush(key, M[i,,drop=TRUE])
    }
    invisible(NULL)
}

## This is atrociously slow:
##
## R> system.time(rInsert(sp))
##    user  system elapsed
##  16.392   0.292 645.643
## R>

system.time(m1 <- do.call(rbind, redisLRange("sp500_R", 0, -1)))
system.time(m2 <- do.call(rbind, redis$lrange("sp500_R", 0, -1)))
identical(m1,m2)
system.time(m3 <- redis$listToMatrix(redis$lrange("sp500_R", 0, -1)))
m4 <- m1
dimnames(m4) <- list()
identical(m4,m3)

## approx factor 20
res <- benchmark(do.call(rbind, redisLRange("sp500_R", 0, -1)),
                 do.call(rbind, redis$lrange("sp500_R", 0, -1)),
                 redis$listToMatrix(redis$lrange("sp500_R", 0, -1)),
                 order="relative", replications=25)[,1:4]
print(res)


cInsert <- function(x) {
    n <- nrow(x)
    key <- "sp500_C"
    if (redisExists(key)) redisDelete(key)
    M <- cbind(as.numeric(index(x)), coredata(x))
    for (i in 1:n) {
        redis$listRPush(key, M[i,])
    }
    invisible(NULL)
}


## approx factor 20
res <- benchmark(do.call(rbind, redisLRange("sp500_R", 0, -1)),
                 do.call(rbind, redis$lrange("sp500_R", 0, -1)),
                 redis$listToMatrix(redis$lrange("sp500_R", 0, -1)),
                 redis$listToMatrix(redis$listRange("sp500_C", 0, -1)),
                 order="relative", replications=25)[,1:4]
print(res)


## R> print(res)
##                                                    test replications elapsed relative
## 4 redis$listToMatrix(redis$listRange("sp500_C", 0, -1))           25   0.296    1.000
## 3    redis$listToMatrix(redis$lrange("sp500_R", 0, -1))           25   2.300    7.770
## 2        do.call(rbind, redis$lrange("sp500_R", 0, -1))           25   2.629    8.882
## 1         do.call(rbind, redisLRange("sp500_R", 0, -1))           25  48.028  162.257
## R>

## redo after Bryan's socket/nagle update to rredis:
##                                                    test replications elapsed relative
## 4 redis$listToMatrix(redis$listRange("sp500_C", 0, -1))           25   0.407    1.000
## 3    redis$listToMatrix(redis$lrange("sp500_R", 0, -1))           25   2.112    5.189
## 2        do.call(rbind, redis$lrange("sp500_R", 0, -1))           25   2.458    6.039
## 1         do.call(rbind, redisLRange("sp500_R", 0, -1))           25  48.367  118.838
## edd@max:~/git/rhiredis/demo$

#test_01_setup <- function() {
suppressMessages(library(RcppRedis))
redis <- new(Redis)

x <- data.frame(x=letters[1:5], y=rnorm(5))
y <- list(foo=list(bar="qux"))
key <- "RcppRedis:test:myset"


#test_02_sadd <- function() {
## add one element into a set
n <- redis$sadd(key, x)
expect_equal(n, 1)


#test_03_sadd_2 <- function() {
## add an already-present element to a set
n <- redis$sadd(key, x)
expect_equal(n, 0)


#test_04_smembers <- function() {
## pull back the set element
mem <- redis$smembers(key)
expect_identical(x, mem[[1]])


#test_05_sadd_3 <- function() {
## add a new element to a set
n <- redis$sadd(key, y)
expect_equal(n, 1)


#test_06_smembers_2 <- function() {
## pull back the set elements
## order not guaranteed
mem <- redis$smembers(key)
checkTrue(identical(mem, list(x, y)) |
          identical(mem, list(y, x)))


#test_07_srem <- function() {
## drop an element from set
n <- redis$srem(key, x)
expect_equal(n, 1)


#test_08_smembers_3 <- function() {
## pull back the remaining element
## order not guaranteed
mem <- redis$smembers(key)
expect_identical(y, mem[[1]])


#test_09_cleanup <- function() {
## delete set
expect_equal(redis$del(key), 1)

#test_01_setup <- function() {
suppressMessages(library(RcppRedis))
redis <- new(Redis)
key <- "RcppRedis:test:myexists"


#test_02_exists <- function() {
redis$set(key, 10)
n <- redis$exists(key)
expect_equal(n, 1)


#test_02_doesNotExist <- function() {
n <- redis$exists("thisKeyIsNotSet-test")
expect_equal(n, 0)


#test_03_cleanup <- function() {
## delete key
expect_equal(redis$del(key), 1)

#test_01_setup <- function() {
suppressMessages(library(RcppRedis))
redis <- new(Redis)

hashname <- "myhash"

xname <- "hat"
xdata <- rnorm(10)

yname <- "cat"
ydata <- rnorm(10)


#test_02_hset <- function() {
## create a hash
n <- redis$hset(hashname, xname, xdata)
expect_equal(n, 1)


#test_03_hset_2 <- function() {
## add an already-present element to a hash
n <- redis$hset(hashname, xname, xdata)
expect_equal(n, 0)


#test_04_hget <- function() {
## pull back the set element
hashdata <- redis$hget(hashname, xname)
expect_identical(xdata, hashdata)


#test_05_setup <- function() {
## add more ele to hash
n <- redis$hset(hashname, yname, ydata)
expect_equal(n, 1)


#test_06_hlen <- function() {
## check for two keys
n <- redis$hlen(hashname)
expect_equal(n, 2)


#test_07_hkeys <- function() {
## check for values hash keys: sort order not given
res <- redis$hkeys(hashname)
expect_equal(sort(res), sort(c(xname,yname)))


#test_08_hgetall <- function() {
## check for all data
res <- redis$hgetall(hashname)
expect_equal(sort(names(res)), sort(c(xname,yname)))
expect_equal(res[[xname]], xdata)
expect_equal(res[[yname]], ydata)


#test_09_hdel <- function() {
## check
n <- redis$hdel(hashname,yname)
expect_equal(n, 1)


#test_09_hdel_1 <- function() {
## check already deleted
n <- redis$hdel(hashname,yname)
expect_equal(n, 0)


#test_09_hdel_2 <- function() {
## check
n <- redis$hdel(hashname,xname)
expect_equal(n, 1)


#test_09_hdel_3 <- function() {
## check hash should now be removed
n <- redis$hexists(hashname, xname)
expect_equal(n, 0)

#test_01_setup <- function() {
suppressMessages(library(RcppRedis))
redis <- new(Redis)

key <- "RcppRedis:exec:test:foo"
val <- "qux"
#}

#test_02_exec <- function() {
## set and get
redis$exec(paste("SET", key, val))
res <- redis$exec(paste("GET", key))
expect_equal(res, val)


#test_03_execError <- function() {
expect_error(redis$exec("LRANGE mylist 0 elephant"))


#test_04_cleanup <- function() {
## delete set
expect_equal(redis$del(key), 1)

#test_01_setup <- function() {
suppressMessages(library(RcppRedis))
redis <- new(Redis)
key <- "RcppRedis:test:myexpires"


#test_02_keyexpiresAfter1s <- function() {
redis$set(key, 10)
redis$expire(key, 1)
Sys.sleep(1.5)
n <- redis$exists(key)
expect_equal(n, 0)


#test_02_keyexpiresAfter2s <- function() {
redis$set(key, 10)
redis$expire(key, 2)
Sys.sleep(1)
n <- redis$exists(key)
expect_equal(n, 1)
Sys.sleep(1.5)
n <- redis$exists(key)
expect_equal(n, 0)


#test_02_keyexpiresAfter1500ms <- function() {
redis$set(key, 10)
redis$expire(key, .9)
Sys.sleep(.3)
n <- redis$exists(key)
expect_equal(n, 1)
Sys.sleep(1.6)
n <- redis$exists(key)
expect_equal(n, 0)


#test_03_cleanup <- function() {
## delete key
expect_equal(redis$del(key), 0)
expect_equal(redis$exists(key), 0)

#test_01_setup <- function() {
suppressMessages(library(RcppRedis))
redis <- new(Redis)

key <- "RcppRedis:test:foo bar"
val <- "qux baz"


#test_02_execv <- function() {
## set and get
redis$execv(c("SET", key, val))
res <- redis$execv(c("GET", key))
expect_equal(res, val)


#test_03_execvError <- function() {
expect_error(redis$execv(c("LRANGE mylist 0 elephant")))


#test_04_cleanup <- function() {
## delete set
n <- redis$execv(c("del", key))
expect_equal(n, 1)

#test_01_setup <- function() {
suppressMessages(library(RcppRedis))
redis <- new(Redis)

exampleNumericElement <- 1.0
exampleCharElement <- "a"
key <- "RcppRedis:test:mylist"
expect_equal(redis$del(key), 0)


#test_02_lpush <- function() {
## add example elements to the list
n1 <- redis$lpush(key, exampleNumericElement)
n2 <- redis$lpush(key, exampleCharElement)
expect_equal(n1, 1)
expect_equal(n2, 2)


#test_03_lpop <- function() {
## remove example elements from the list
res1 <- redis$lpop(key)
res2 <- redis$lpop(key)
expect_equal(res1, exampleCharElement)
expect_equal(res2, exampleNumericElement)


#test_04_lpopnull <- function() {
## try to lpop beyond list extent
res <- redis$rpop(key)
expect_equal(res, NULL)


#test_05_rpush <- function() {
## add example elements to the list
n1 <- redis$rpush(key, exampleNumericElement)
n2 <- redis$rpush(key, exampleCharElement)
expect_equal(n1, 1)
expect_equal(n2, 2)


#test_06_rpop <- function() {
## remove example elements from the list
res1 <- redis$rpop(key)
res2 <- redis$rpop(key)
expect_equal(res1, exampleCharElement)
expect_equal(res2, exampleNumericElement)


#test_07_rpopnull <- function() {
## try to rpop beyond list extent
res <- redis$rpop(key)
expect_equal(res, NULL)


#test_08_ltrim <- function() {
##try to trim a list
redis$lpush(key, 1)
redis$lpush(key, 2)
redis$lpush(key, 3)
redis$ltrim(key, 0, 1)
res <- redis$lrange(key, 0, 100)
expect_equal(res,list(3,2))
expect_equal(redis$del(key), 1)


#test_09_cleanup <- function() {
## delete key
expect_equal(redis$del(key), 0)


## check lrem
redis$del(key)
elem <- "abc"
redis$lpush(key, elem)
redis$lpush(key, elem)
redis$lpush(key, elem)
redis$lpush(key, elem)
expect_equal(redis$llen(key), 4)
redis$lrem(key, 1, elem)
expect_equal(redis$llen(key), 3)
redis$lrem(key, -1, elem)
expect_equal(redis$llen(key), 2)
expect_equal(redis$lpop(key), elem)
expect_equal(redis$lpop(key), elem)
expect_equal(redis$keys(key), character())

## check lmove
altkey <- "RcppRedis:test:myotherlist"
redis$del(altkey)
redis$rpush(key, 1)
redis$rpush(key, 2)
redis$rpush(key, 3)
redis$lmove(key, altkey, "LEFT", "RIGHT")
expect_equal(redis$llen(key), 2)
expect_equal(redis$llen(altkey), 1)
redis$lmove(key, altkey, "LEFT", "LEFT")
expect_equal(redis$llen(key), 1)
expect_equal(redis$llen(altkey), 2)
expect_equal(redis$lpop(key), 3)    # as 1 and 2 have been moved (both from left)
expect_equal(redis$lpop(altkey), 2) # as 2 was inserted to the left
expect_equal(redis$lpop(altkey), 1) # as 1 remains

exit_file("Skip this test")

#test_01_setup <- function() {
suppressMessages(library(RcppRedis))
## we start the Redis server for this test as a slave so we don't clobber the main running version of redis for the rest of the tests
tmpfile <- tempfile()
writeLines("requirepass badPassword", tmpfile)
system(paste("redis-server", tmpfile, "--port 7777 --slaveof localhost 6379"), wait=FALSE)
## Wait for server to come up
Sys.sleep(5)


#test_02_testUnauth <- function () {
redis <- new(RcppRedis::Redis, "localhost", 7777, auth = "", 10)
## we expect an exception because we haven't send the password
expect_error(redis$ping())


#test_03_testAuth <- function () {
redis <- new(RcppRedis::Redis, "localhost", 7777, auth = "badPassword", 10)
expect_equal(redis$ping(), "PONG")


#test_04_killServer <- function() {
## confirm server is up
expect_equal(redis$ping(),"PONG")
## kill server
expect_error(redis$exec("SHUTDOWN"))


#test_05_cleanup <- function() {
#NULL

if (!requireNamespace("rredis", quietly=TRUE)) exit_file("Skip this test")

#test_01_setup <- function() {
suppressMessages({
    library(datasets)
    library(rredis)
    library(RcppRedis)
})

rredis::redisConnect(nodelay=FALSE) 	# rredis connection object, but no tcpdelay
                                        # as our use of hiredis seesm to interfere

redis <- new(Redis)                	# RcppRedis object

data(trees)
fit <- lm(log(Volume) ~ log(Girth) + log(Height), data=trees)


#test_02_treesExternalSerialize <- function() {

## set a externally serialized object
key <- "RcppRedis:test:foo"
redis$set(key, serialize(fit, NULL, ascii=TRUE))

## retrieve with rredis
fit2 <- rredis::redisGet(key)

## check
expect_equal(fit, fit2)


#test_03_treesInternalSerialize <- function() {
## or serialize an object internally
key <- "RcppRedis:test:foo2"
redis$set(key, fit)

## retrieve with rredis
fit3 <- rredis::redisGet(key)

## check
expect_equal(fit, fit3)


#test_04_treesRRedis <- function() {
## retrieve with rredis
key <- "RcppRedis:test:foo2"
fit4 <- redis$get(key)

## check
expect_equal(fit, fit4)


#test_05_ping <- function() {
res <- redis$ping()
expect_equal(res, "PONG")

#test_06_cleanup <- function() {
expect_equal(redis$del(c("RcppRedis:test:foo","RcppRedis:test:foo2")), 2)

#!/bin/bash

function runShell {
    ./writeShell.sh

    ./readShell.sh
    ./readShell.sh

}

function runPython {
    ./writePython.py

    ./readPython.py
    ./readPython.py

}

function cleanup {
    # cleanup
    redis-cli del 'ex:ascii:simpleString'
    redis-cli del 'ex:ascii:scalarVal'
    redis-cli del 'ex:ascii:vectorVal'
}


runShell
runPython
cleanup

#!/bin/bash

key1="ex:ascii:simpleString"
val1="abracadrabra"
res=$(redis-cli set ${key1} ${val1})
echo "Set '${val1}' under '${key1}' with result ${res}"

key2="ex:ascii:scalarVal"
val2=42
res=$(redis-cli rpush ${key2} ${val2})
echo "Pushed '${val2}' under '${key2}' with result ${res}"

key3="ex:ascii:vectorVal"
val3="40,41,42"
res=$(redis-cli rpush ${key3} ${val3})
echo "Pushed '${val3}' under '${key3}' with result ${res}"

#!/bin/bash

key1="ex:ascii:simpleString"
val1=$(redis-cli get ${key1})
echo "Got'ed '${val1}' from '${key1}'"

key2="ex:ascii:scalarVal"
val2=$(redis-cli lpop ${key2})
echo "LPop'ed '${val2}' from '${key2}'"

key3="ex:ascii:vectorVal"
val3=$(redis-cli lpop ${key3})
echo "LPop'ed '${val3}' from '${key3}'"
